<template>
  <div id="unit" class="flex-row">
    <div class="basic-main" @keyup.enter="search">
      <div class="flex" v-if="!show">
        <criteria-paged :model="model" v-ref:paged>
          <criteria partial='criteria' @condition-changed='$parent.selfSearch' v-ref:cri>
            <div novalidate class="form-horizontal select-overspread container-fluid auto" partial>
              <div class="row">
                <div class="col-sm-2 form-group">
                  <label for="startDate" class="font_normal_body">开始日期</label>
                  <datepicker id="startDate" placeholder="开始日期" style="width:60%"
                              v-model="$parent.$parent.startDate"
                              :value.sync="$parent.$parent.startDate"
                              :format="'yyyy-MM-dd'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group">
                  <label for="endDate" class="font_normal_body">结束日期</label>
                  <datepicker id="endDate" placeholder="结束日期" style="width:60%"
                              v-model="$parent.$parent.endDate"
                              :value.sync="$parent.$parent.endDate"
                              :format="'yyyy-MM-dd'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group">
                  <label for="endDate" class="font_normal_body">小区名称</label>
                  <v-select :value.sync="model.f_residential_area_id"
                            class="select_list select"
                            enter-push v-model="model.f_residential_area_id" multiple="true"
                            @select-search="$parent.$parent.getAreaList"
                            :options='$parent.$parent.areaList' placeholder='小区名称'
                            condition="f_residential_area_id in {}">
                  </v-select>
                </div>
                <div class="span" style="float:right;">
                  <button class="button_search button_spacing" @click="search()">查询</button>
                  <button class="button_clear  button_spacing" @click="$parent.$parent.clear()">清空</button>
                  <export-excel :data="$parent.$parent.getCondition"
                                :field="$parent.$parent.getfield"
                                :header="$parent.$parent.other"
                                :footer="$parent.$parent.footer"
                                sqlurl="api/af-revenue/logic/openapi/exportfile"
                                sql-name="manage_wallHangingFurnaceUserQuery"
                                template-name='壁挂炉用户查询'
                                :choose-col="true"></export-excel>
                  <print-data :sum-field="$parent.$parent.getfield" :model="$parent.model"
                              :field="$parent.$parent.getfield"
                              titletable="壁挂炉用户查询" :starthead="$parent.$parent.startDate"
                              :defaultfield="$parent.$parent.defaultfield"
                              :sumsmodel="$parent.$parent.sumsmodel"></print-data>
                  <div
                    :class="{'button_shrink_top':$parent.$parent.criteriaShow,'button_shrink_bottom':!$parent.$parent.criteriaShow}"
                    @click="$parent.$parent.hidden()"
                    class="button_spacing"
                    style="float: right"></div>
                </div>
              </div>
              <div class="row" v-if="$parent.$parent.criteriaShow">
                <res-select-group
                  :show-component="['company','department','operator']"
                  :initres="$parent.$parent.initres"
                  @re-res="$parent.$parent.getRes"
                  :specialquery="true"
                  v-ref:sel
                ></res-select-group>
                <div class="col-sm-2 form-group">
                  <label class="font_normal_body">表具类型</label>
                  <v-select :value.sync="model.f_meter_type"
                            :search="false"
                            v-model="model.f_meter_type"
                            condition="f_meter_type = '{}'"
                            :options='$parent.$parent.metertypes'
                            close-on-select
                            placeholder='请选择'
                  ></v-select>
                </div>
                <div class="col-sm-2 form-group" >
                  <label class="font_normal_body">经销商&nbsp;&nbsp;&nbsp;&nbsp;</label>
                  <v-select :value.sync="model.f_distributor" v-model="model.f_distributor"
                            placeholder='壁挂炉经销商'
                            :value-single="true"
                            condition="f_distributor = '{}'"
                            :options='$parent.$parent.distributor'
                            close-on-select>
                  </v-select>
                </div>
              </div>
            </div>
          </criteria>
          <data-grid :model="model" partial='list' class="list_area table_sy" v-ref:grid :classname="$parent.classname">
            <template partial='head'>
              <tr>
                <th>
                  <nobr>用户编号</nobr>
                </th>
                <th>
                  <nobr>用户名称</nobr>
                </th>
                <th>
                  <nobr>联系电话</nobr>
                </th>
                <th>
                  <nobr>所在小区</nobr>
                </th>
                <th>
                  <nobr>详细地址</nobr>
                </th>
                <th>
                  <nobr>累购金额</nobr>
                </th>
                <th>
                  <nobr>已用量</nobr>
                </th>
                <th>
                  <nobr>原气价类型</nobr>
                </th>
                <th>
                  <nobr>现气价类型</nobr>
                </th>
                <th>
                  <nobr>气价变更时间</nobr>
                </th>
                <th>
                  <nobr>表具类型</nobr>
                </th>
                <th>
                  <nobr>经销商</nobr>
                </th>
              </tr>
            </template>
            <template partial='body'>
              <td style="text-align: center;">
                <nobr>{{ row.f_userinfo_code }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_user_name }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_user_phone }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_residential_area }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_address }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_collection }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_meter_base }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_old_price_type }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_new_price_type }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_operate_date }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_meter_type }}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{ row.f_distributor }}</nobr>
              </td>
            </template>
            <template partial='foot'></template>
          </data-grid>
        </criteria-paged>
        <table class="table-hover">
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold">
              汇总信息
            </td>
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              期初户数:&emsp;{{ sumsmodel.f_start_count }}
            </td>
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              新增户数:&emsp;{{ sumsmodel.f_add_count }}
            </td>
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              期末户数:&emsp;{{ sumsmodel.f_end_count }}
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</template>
<script>
import {PagedList, HttpResetClass} from 'vue-client'
import defaultPrint from '../config/DefaultPrint'
import exportConfig from '../config/exportConfig'

let readySomething = async function (self) {
  self.startDate = self.$login.toStandardDateString()
  self.endDate = self.$login.toStandardDateString()
  self.getAreaList()
}
export default {
  title: '单位用气售气',
  data() {
    return {
      condition: '',
      condition2: '',
      orgConditionStr: '',
      criteriaShow: false,
      other: [],
      footer: [],
      model: new PagedList('api/af-revenue/sql/manage_wallHangingFurnaceUserQuery', 20, {
        startDate: 'this.model.startDate',
        endDate: 'this.model.endDate',}),
      gasproperties: [],
      show: false,
      rowdata: {},
      areaList: [],
      modelval: [],
      startDate: '',
      endDate: '',
      inputtouPerson: [],
      printshow: false,
      all: false,
      fields: {},
      thead: '',
      tfoot: '',
      defaultfield: [],
      sumsmodel: {
        f_start_count: 0 ,
        f_add_count: 0 ,
        f_end_count: 0 ,
      },
      sumExport: {'f_start_count': '期初户数', 'f_add_count': '新增户数', 'f_end_count': '期末户数'},
      initres: {
        org: [this.$login.f.orgid],
        dep:[],
        user:[]
      },
    }
  },
  ready() {
    readySomething(this).then(() => {
      this.$emit('ready')
    }).catch((error) => {
      this.$emit('error', error)
    })
  },
  methods: {
    async getSumsModel () {
      let http = new HttpResetClass()
      let data = {
        endDate: this.$refs.paged.$refs.cri.model.endDate,
        condition: this.condition2
      }
      let res = await http.load('POST', 'api/af-revenue/logic/manage_getEndUserCount', {data: data})
      this.sumsmodel.f_end_count = res.data.num
      this.sumsmodel.f_add_count =  this.$refs.paged.$refs.grid.model.count
      this.sumsmodel.f_start_count = parseInt(res.data.num) - parseInt(this.$refs.paged.$refs.grid.model.count)
    },
    getAreaList (searchText) {
      let condition = ' 1 = 1 '
      if (searchText) {
        condition = ` f_residential_area like '%${searchText}%' `
      }
      let HttpReset = new HttpResetClass()
      HttpReset.load('POST', 'api/af-revenue/sql/manageSingleTable?pageNo=1&pageSize=100', {
        data: {
          items: 'f_residential_area, id',
          tablename: 't_area',
          orderitem: 'id desc',
          condition: condition
        }
      }, {resolveMsg: null, rejectMsg: '获取小区信息失败!'}).then((req) => {
        let redata = []
        req.data.forEach((row, n) => {
          redata[n] = {
            label: row.f_residential_area,
            value: row.id
          }
        })
        this.areaList = [{label: '全部', value: ''}, ...redata]
      })
    },
    clear() {
      //清空部门和人员
      this.$refs.paged.$refs.cri.$refs.sel.$children[1].selectres = []
      //部门和人员变为全选
      this.$refs.paged.$refs.cri.$refs.sel.$children[1].$children[0].isSelectAll = false
      this.$refs.paged.$refs.cri.$refs.sel.$children[2].$children[0].isSelectAll = false
      Object.keys(this.$refs.paged.$refs.cri.model).forEach((key) => {
        this.$refs.paged.$refs.cri.model[key] = []
      })
    },
    hidden() {
      this.criteriaShow = !this.criteriaShow
    },
    getotherfooter() {
      this.other = []
      this.footer = []
      let exportdata = this.getCondition
      let otherInData = []
      otherInData.push(`导出时间: ${this.$login.toStandardTimeString()}`)
      let footerData = [], exportfield = this.sumExport
      footerData.push('合计')
      let self = this
      for (var field in self.sumsmodel) {
        footerData.push(`${exportfield[field]}合计:${self.sumsmodel[field]}`)
      }
      this.footer.push(footerData)
      this.other.push(otherInData)
    },
    search() {
      this.$refs.paged.$refs.cri.search()
    },
    appendCondition(data) {
      console.log('data=====>', data)
      let stringValue = ''
      for (var i = 0; i < data.length; i++) {
        if (data[i]) {
          if (i === data.length - 1) {
            stringValue = stringValue + "'" + data[i] + "'"
          } else {
            stringValue = stringValue + "'" + data[i] + "',"
          }
        }
      }
      return stringValue
    },
    async selfSearch(args) {
      this.condition2 = args.condition + ' and f_orgid = ' + this.$login.f.orgid
      if (!this.orgConditionStr) {
        args.condition = `${args.condition}` + ' and f_orgid = ' + this.$login.f.orgid
      } else {
        args.condition = `${args.condition}` + this.orgConditionStr
      }
      this.$refs.paged.$refs.cri.model.startDate = this.startDate
      this.$refs.paged.$refs.cri.model.endDate = this.endDate
      this.condition = args.condition
      console.log("查看条件", this.condition)
      await this.model.search(args.condition, args.model)
      await this.getSumsModel()
    },
    getRes(obj) {
      this.orgConditionStr = obj
    },
    stamp() {
      this.all = false
      //默认选择要打印的列
      this.modelval = defaultPrint.config
      this.fields = this.getfield
      console.log('所有打印字段', this.fields)
      this.printshow = true
      this.put()
    },
    put() {
      // 对Modelval进行排序
      this.sortModelval()
      this.thead = `<tr><th colspan=${this.modelval.length}>用户查询</th></tr><tr>`
      for (let key of this.modelval) {
        this.thead += '<th>' + this.fields[key] + '</th>'
      }
      this.thead += '</tr>'
    },
    print() {
      this.$refs.print.PrintAsFile()
      this.printshow = false
    },
    dealmsg(val) {
      console.log('---------------dealmsg')
      this.rowdata = val
      this.show = true
      val.model = this.model.model
      this.$dispatch('deal-msg', val)
    },
    close() {
      this.printshow = false
      this.all = false
    },
    // 对选择的列进行排序
    sortModelval() {
      let sortModel = []
      Object.keys(this.fields).forEach((key) => {
        if (this.modelval.includes(key)) {
          sortModel.push(key)
        }
      })
      this.modelval = sortModel
      console.log('选择的打印的字段', this.modelval)
    }
  },
  watch: {
    'all'(val) {
      if (val) {
        this.modelval = this.bodyData
      } else {
        this.modelval = defaultPrint.config
        this.put()
      }
    },
    sumsmodel: {
      handler: function (val) {
        this.getotherfooter()
      },
      deep: true
    },
    'modelval.length'() {
      this.put()
    }
  },
  computed: {
    getCondition() {
      return {
        condition: this.condition,
        startDate: this.$refs.paged.$refs.cri.model.startDate,
        endDate: this.$refs.paged.$refs.cri.model.endDate
      }
    },
    getfield() {
      return exportConfig.wallHangingFurnaceUserConfig
    },
    distributor() {
      return [{label: ' 全部 ', value: ''}, ...this.$appdata.getParam('经销商')]
    },
    metertypes() {
      return [{label: ' 全部 ', value: ''}, ...this.$appdata.getParam('气表类型')]
    }
  }
}
</script>

